#include <code/query/logical-or.hxx>

#include <sstream>

namespace code::query
{

  logical_or_t::
  logical_or_t(expression_t left, expression_t right)
    : left_{move(left)},
      right_{move(right)}
  {}

  logical_or_t::
  logical_or_t(source_location_t origin,
               expression_t left,
               expression_t right)
    : origin_{move(origin)},
      left_{move(left)},
      right_{move(right)}
  {}

  source_location_t const&
  logical_or_t::
  origin() const
  {
    return origin_;
  }

  expression_t const&
  logical_or_t::
  left() const
  {
    return left_;
  }

  expression_t const&
  logical_or_t::
  right() const
  {
    return right_;
  }

  string
  to_string(logical_or_t const& e)
  {
    std::stringstream str;

    str << to_string(e.left());
    str << " or ";
    str << to_string(e.right());

    return str.str();
  }

} // namespace code::query
