#include <code/query/parse.hxx>

#include <code/query/lexical-analyzer.hxx>
#include <code/query/syntactical-analyzer.hxx>

namespace code::query
{

  query_t
  try_parse(string const& q, parse_context_t& context)
  {
    string_lexical_analyzer_t lexer{q.begin(), q.end()};
    return syntactical_analyzer_t{lexer, context}.try_parse();
  }

} // namespace code::query
