#ifndef code__query__syntactical_analyzer_hxx_
#define code__query__syntactical_analyzer_hxx_

#include <code/query/expression.hxx>
#include <code/query/lexical-analyzer.hxx>
#include <code/query/parse-context.hxx>
#include <code/query/query.hxx>
#include <code/query/types.hxx>

namespace code::query
{

  class syntactical_analyzer_t
  {
  public:
    syntactical_analyzer_t(lexical_analyzer_t&, parse_context_t&);

    lexical_analyzer_t&
    lexer();

    parse_context_t&
    context();

    query_t
    try_parse();

  private:
    optional<expression_t>
    try_parse_primary_expression();

    optional<expression_t>
    try_parse_logical_and();

    optional<expression_t>
    try_parse_logical_or();

    optional<expression_t>
    try_parse_expression();

  private:
    lexical_analyzer_t& lexer_;
    parse_context_t& context_;

  };

} // namespace code::query

#endif
