#ifndef code__query__tag_hxx_
#define code__query__tag_hxx_

#include <code/query/expression.hxx>
#include <code/query/source-location.hxx>
#include <code/query/term.hxx>
#include <code/query/types.hxx>

namespace code::query
{

  class tag_t
  {
  public:
    tag_t(string, term_t);

    tag_t(source_location_t, string, term_t);

    source_location_t const&
    origin() const;

    string const&
    identifier() const;

    term_t const&
    value() const;

  private:
    source_location_t origin_;

    string identifier_;
    term_t value_;
  };

  string
  to_string(tag_t const& e);

} // namespace imperium::contract::query

#endif
